<!--
  Tom Vtek - slo 17
-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <title>Zpracovn mapy</title>
  </head>
  <body>
  <?php
    function posun ($x, $y, $v, $log) {
      global $mapa, $reseni;
      
      if ($mapa[$y][$x] == "." OR $mapa[$y][$x] == ":" OR $mapa[$y][$x] == "S"):
        posun($x,$y,($v+1),$log."XX"."0, 0");
        posun(($x+$v),$y,($v+1),$log."XX"."1, 0");
        posun(($x-$v),$y,($v+1),$log."XX"."-1, 0");
        posun($x,($y+$v),($v+1),$log."XX"."0, 1");
        posun($x,($y-$v),($v+1),$log."XX"."0, -1");
        posun(($x-$v),($y-$v),($v+1),$log."XX"."-1, -1");
        posun(($x+$v),($y+$v),($v+1),$log."XX"."1, 1");
        posun(($x-$v),($y+$v),($v+1),$log."XX"."-1, 1");
        posun(($x+$v),($y-$v),($v+1),$log."XX"."1, -1");
      else:
        $reseni .= "RR".$log;        
      endif;        
    } 
  
    // nacte obsah souboru do retezce
    $filename = $_POST["soubor"];
    
    @$fd = fopen ($filename, "r");
    @$obsah = fread ($fd, filesize ($filename));
    @fclose ($fd);
    
    if (!$fd):
      echo "<h2>Chyba!</h2><p>Soubor neexistuje! Vrate se prosm na pedchoz strnku a zadejte sprvnou cestu!</p>";
    else:
      $prvni_radek = explode("<br />", nl2br($obsah));
      $prvni_radek = $prvni_radek[1];
      $sloupcu = strlen($prvni_radek);
      $radek = strlen($obsah)/$sloupcu;
      $mapa = "";
      
      // naplni pole MAPA udaji ze souboru
      $co = 0;
      for ($i = 0; $i < $radek; $i++):
        for ($ii = 0; $ii < $sloupcu; $ii++):
          $mapa[$i][$ii] = $obsah[$co];
          if ($mapa[$i][$ii] == "S"):
            $zac_x = $ii;
            $zac_y = $i; 
          endif; 
          $co++;
        endfor;
      endfor;
      
      if ($sloupcu < 50) $size = 20;
      elseif ($sloupcu < 100) $size = 10;
      else $size = 4; 
      
      if ($sloupce > 255 OR $radky > 255):
        echo "<h2>Chyba!</h2><p>Mapa m vt ne povolen rozmry (255x255)!</p>";      
      else:  
        echo "<h2>Zobrazen mapy:</h2><p>Mapa m ".($radek*$sloupcu)." polek (".$radek." dek na ".$sloupcu." sloupc).</p>";
   
        echo "<table>";     
        for ($i = 0; $i < $radek; $i++):
          echo "<tr>";
          for ($ii = 0; $ii < $sloupcu; $ii++):
            switch ($mapa[$i][$ii]) {
                case "X":
                    echo "<td style=\"width:$size;height:$size;background-color:black\"></td>";
                    break;
                case ".":
                    echo "<td style=\"width:$size;height:$size;background-color:green\"></td>";
                    break;
                case ":":
                    echo "<td style=\"width:$size;height:$size;background-color:#33ff33\"></td>";
                    break;
                case "S":
                    echo "<td style=\"width:$size;height:$size;background-color:blue\"></td>";
                    break;
                case "C":
                    echo "<td style=\"width:$size;height:$size;background-color:purple\"></td>";
                    break;
            }
          endfor;
          echo "</tr>";
        endfor;
        echo "</table>"; 
        
        echo "<h3>Vysvtlivky</h3>";
        echo "<table>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:black\"></td><td>Zakzan polko</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:green\"></td><td>Cesta</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:#33ff33\"></td><td>Bezpen cesta</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:blue\"></td><td>Start</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:purple\"></td><td>Cl</td></tr>";
        echo "</table>";
        
        
        echo "<h4>Poznmka pro porotce</h4><p>Program spluje jen prvn z kol, zbytek programu jsem nedoladil, popsal jsem cel mj algoritmus ve zdrojovm kdu souboru \"zpracuj.php\", kde je vtina programu tak dokonena, ale z dvodu nedoladn zapoznmkovna. Tam se dozvte vce. Dkuji!</p>";
        
        /*
        
        POZNAMKA PRO POROTCE:
        **********************
        Zde je nedodelany kod, ktery bohuzel neni funkcni, takze zrejme nebude
        zahrnut do hodnoceni, ovsem algorimtus jako takovy (alespon to predpokladam)
        by mel byt hodnocen, a tak se pokusim nastinit, jaky algoritmus jsem chtel
        pouzit/jsem pouzil.
        
        Nejprve jsem si z natenho souboru nahrl data do dvou rozmrnho pole.
        Tak, aby to pole odpovdalo umstn jednotlivch znak v souboru.
        
        Potom jsem si z tohoto pole vypsal data do tabulky -> zobrazil jsem tedy
        mapu a tm splnil prvn kol.
        
        Dle je u bohuel program nefunkn, i kdy znan st kdu je ji napsna,
        bylo by ji teba jen upravit a optimalizovat a dopsat uloen pokyn do 
        souboru.
        
        Postupoval bych zhuba takto: vyuil bych rekurzn funkce "posun", kter by
        vdy z danho polka "posouvala" auto-automobil dl, piem by prola
        vechny monosti, tm e by se postupn volala znovu a znovu.
        
        V ppad, e by dolo k nalezen cle, napsal bych do logu (promnn)
        jak jsem provdl operace s autkem, v ppad nenalezen cle, bych
        danou vtev rekurze ukonil. 
        
        Potom (po ukonen cel rekurze) bych analyzoval log z promnn, tu bych rozsekal
        a zjistil, kter z cest by byla nejrychlej. Tu bych vypsal a nakonec bych
        vypsal do souboru i pokynu pro auto-automobil.*/
        
           
          
                        
        
      /*  
        $reseni = "";
        posun(($zac_x), ($zac_y), 0, ""); 
        
        $logy = explode("RR",$reseni);
        
        $nej = 0;
        $nej_pocet = 0;
        
        function kdo_je_nej ($log ,$klic) {
          global $nej_pocet, $nej;
          
          $casti = explode("XX",$log);
          if (count($casti) < $nej_pocet OR $nej == 0):
            $nej = $klic;
            $nej_pocet = count($casti); 
          endif;
        }
        
        array_walk ($logy, 'kdo_je_nej');
        
        $nejlepsi = explode("XX", $logy[$klic]);
        $nejlepsi_s_nl = str_replace("XX", "\n");
        
        $rych = 0;
        for ($s = 0; $s < count($nejlepsi); $s++):
          $rych++;
          
          $kam = explode(", ",$nejlepsi[$s]);
                    
          $mapa[eval($zac_y.$kam[1]."*".$rych)][eval($zac_x.$kam[0]."*".$rych)] = "O";  
        endfor;                        
        echo "<h2>Zobrazen projet:</h2>";
   
        echo "<table>";     
        for ($i = 0; $i < $radek; $i++):
          echo "<tr>";
          for ($ii = 0; $ii < $sloupcu; $ii++):
            switch ($mapa[$i][$ii]) {
                case "X":
                    echo "<td style=\"width:$size;height:$size;background-color:black\"></td>";
                    break;
                case ".":
                    echo "<td style=\"width:$size;height:$size;background-color:green\"></td>";
                    break;
                case ":":
                    echo "<td style=\"width:$size;height:$size;background-color:#33ff33\"></td>";
                    break;
                case "S":
                    echo "<td style=\"width:$size;height:$size;background-color:blue\"></td>";
                    break;
                case "O":
                    echo "<td style=\"width:$size;height:$size;background-color:yellow\"></td>";
                    break;
                case "C":
                    echo "<td style=\"width:$size;height:$size;background-color:purple\"></td>";
                    break;
            }
          endfor;
          echo "</tr>";
        endfor;
        echo "</table>";

        echo "<h3>Vysvtlivky</h3>";
        echo "<table>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:black\"></td><td>Zakzan polko</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:green\"></td><td>Cesta</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:#33ff33\"></td><td>Bezpen cesta</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:blue\"></td><td>Start</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:yellow\"></td><td>Cesta auto-automobilu</td></tr>";
        echo "<tr><td style=\"width:$size;height:$size;background-color:purple\"></td><td>Cl</td></tr>";
        echo "</table>";*/   

      endif;   
    endif;
    
    
    
    
  ?>
  </body>
</html>
